//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "ib.h"
#include "AboutForm.h"
#include "settingsForm.h"
#include "Basket.h"
#include "Player.h"
#include "ResultDlg.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
Basket basket;
Player player(&basket, 5);
enum FIRST_STEPS {PLAYER, COMP, RANDOM};
short firstStep;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
  steps[0] = sbStep1;
  steps[1] = sbStep2;
  steps[2] = sbStep3;
  steps[3] = sbStep4;
  steps[4] = sbStep5;
  steps[5] = sbStep6;
  steps[6] = sbStep7;
  steps[7] = sbStep8;
  steps[8] = sbStep9;

  balls[0] = Shape1;
  balls[1] = Shape2;
  balls[2] = Shape3;
  balls[3] = Shape4;
  balls[4] = Shape5;
  balls[5] = Shape6;
  balls[6] = Shape7;
  balls[7] = Shape8;
  balls[8] = Shape9;

  FillShapes();
  DisableBtns();
  firstStep = PLAYER;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::N9Click(TObject *Sender)
{
  fSettings->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::N2Click(TObject *Sender)
{
  bNextStep->Enabled = true;
  if(fSettings->cbUseSettings->Checked == true)
  {
    firstStep = fSettings->rgFirstStep->ItemIndex;
    r = StrToInt(fSettings->cbRed->Text);
    b = StrToInt(fSettings->cbBlue->Text);
    g = StrToInt(fSettings->cbGreen->Text);
    basket.setNewVal(r, b, g);
    player.setRecDepth(StrToInt(fSettings->cbDifficult->Text));
  }
  else
  {
    basket.setNewVal();
    firstStep = PLAYER;
  }
  reHistory->Lines->Add(" ");
  reHistory->SetFocus();
  reHistory->SelStart = reHistory->GetTextLen();
  if(firstStep == RANDOM)
  {
    srand(time(NULL));
    firstStep = rand()%2;
  }
  if(firstStep == COMP)
    CompStep();
  FillShapes();
  DisableBtns();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FillShapes()
{
  for(short i = 0; i < 3; i++)
    if(i < basket.getBalls(RED))
      balls[i]->Brush->Color = clRed;
    else
      balls[i]->Brush->Color = clWhite;
  for(short i = 0; i < 3; i++)
    if(i < basket.getBalls(BLUE))
      balls[i + 3]->Brush->Color = clBlue;
    else
      balls[i + 3]->Brush->Color = clWhite;
  for(short i = 0; i < 3; i++)
    if(i < basket.getBalls(GREEN))
      balls[i + 6]->Brush->Color = clGreen;
    else
      balls[i + 6]->Brush->Color = clWhite;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::bNextStepClick(TObject *Sender)
{
  for(int i = 0; i < 9; i++)
    if(steps[i]->Down == true)
    {
      basket.Add(i%3 + 1, i/3);
      FillShapes();
      DisableBtns();
      AddInfo(i%3 + 1, i/3, false);
      if(basket.isFull())
      {
        reHistory->SelAttributes->Color = clFuchsia;
        reHistory->Lines->Add("---------------");
        reHistory->Lines->Add("  !!!!!!!");
        reHistory->Lines->Add("---------------");
        reHistory->SetFocus();
        reHistory->SelStart = reHistory->GetTextLen();
        OKBottomDlg->Label1->Font->Color = clRed;
        OKBottomDlg->Label1->Caption = " !";
        if(OKBottomDlg->ShowModal() == IDOK)
          N2Click(Sender);
        else
          bNextStep->Enabled = false;
        return;
      }
      CompStep();
      return;
    }
  Application->MessageBoxA(" ", "", MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AddInfo(short n, short color, bool isComp)
{
  AnsiString info;
  reHistory->SelAttributes->Color = clBlack;
  if(isComp)
    info += " : ";
  else
    info += " : ";
  if(color == RED)
  {
    reHistory->SelAttributes->Color = clRed;
    info += IntToStr(n) + " " + "()";
  }
  if(color == BLUE)
  {
    reHistory->SelAttributes->Color = clBlue;
    info += IntToStr(n) + " " + "()";
  }
  if(color == GREEN)
  {
    reHistory->SelAttributes->Color = clGreen;
    info += IntToStr(n) + " " + "()";
  }
  reHistory->SetFocus();
  reHistory->Lines->Add(info);
  reHistory->SelStart = reHistory->GetTextLen();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CompStep()
{
  bNextStep->Enabled = false;
  short c, n;
  if(!player.NextStep(n, c))
  {
    Application->MessageBoxA("   ", "", MB_OK);
    return;
  }
  AddInfo(n, c, true);
  FillShapes();
  DisableBtns();
  bNextStep->Enabled = true;
  if(basket.isFull())
  {
    reHistory->SelAttributes->Color = clBlack;
    reHistory->Lines->Add("---------------");
    reHistory->Lines->Add(" .  -  - .");
    reHistory->Lines->Add("---------------");
    reHistory->SetFocus();
    reHistory->SelStart = reHistory->GetTextLen();
    OKBottomDlg->Label1->Font->Color = clBlack;
    OKBottomDlg->Label1->Caption = " .";
    if(OKBottomDlg->ShowModal() == IDOK)
      N2Click(this);
    else
      bNextStep->Enabled = false;
  }
  return;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DisableBtns()
{
  for(int color = 0; color < 3; color++)
  {
    int last = color*3 + 2;//    
    short n = basket.getBalls(color);
    for(int i = 0; i < 3; i++)
      if(i < n)
        steps[last - i]->Enabled = false;
      else
        steps[last - i]->Enabled = true;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N8Click(TObject *Sender)
{
  AboutBox->ShowModal();      
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N4Click(TObject *Sender)
{
  Form1->Close();      
}
//---------------------------------------------------------------------------

